Index: c/src/lib/libbsp/powerpc/mvme5500/irq/BSP_irq.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/irq/BSP_irq.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
+++ c/src/lib/libbsp/powerpc/mvme5500/irq/BSP_irq.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -0,0 +1,514 @@
+/*  BSP_irq.c
+ *
+ *  This file contains the implementation of the function described in irq.h
+ *
+ *  Copyright (C) 1998, 1999 valette@crf.canon.fr
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  Acknowledgement to Till Straumann <strauman@slac.stanford.edu>
+ *  for some inputs in May 2004.
+ *
+ *  Copyright 2003, 2004, 2005, 2007  Shuchen Kate Feng <feng1@bnl.gov>,
+ *            NSLS, Brookhaven National Laboratory. All rights reserved.
+ *
+ *  1) Used GT_GPP_Value register instead of the GT_GPP_Interrupt_Cause
+ *     register to monitor the cause of the level sensitive interrupts.
+ *     (Copyright : NDA item)
+ *  2) The implementation of picPrioTable[] is an original work by the
+ *     author to optimize the software IRQ priority scheduling because
+ *     Discovery controller does not provide H/W IRQ priority schedule. 
+ *     It ensures the fastest/faster interrupt service to the
+ *     highest/higher priority IRQ, if pendig.
+ *  3) _CPU_MSR_SET() needs RTEMS_COMPILER_MEMORY_BARRIER()
+ * 
+ */
+
+#include <stdio.h>  
+#include <rtems/system.h>
+#include <bsp.h>
+#include <bsp/irq.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/apiext.h>
+#include <libcpu/raw_exception.h>
+#include <rtems/rtems/intr.h>
+#include <libcpu/io.h>
+#include <libcpu/byteorder.h>
+#include <bsp/vectors.h>
+
+#include <rtems/bspIo.h> /* for printk */
+#include "bsp/gtreg.h"
+
+#define HI_INT_CAUSE 0x40000000
+
+#define MAX_IRQ_LOOP 20
+
+#define _MSR_GET( _mask) \
+  do { \
+     RTEMS_COMPILER_MEMORY_BARRIER(); \
+     _CPU_MSR_GET( _mask); \
+     RTEMS_COMPILER_MEMORY_BARRIER(); \
+  } while (0);
+
+#define _MSR_SET( _mask) \
+  do { \
+     RTEMS_COMPILER_MEMORY_BARRIER(); \
+     _CPU_MSR_SET( _mask); \
+     RTEMS_COMPILER_MEMORY_BARRIER(); \
+  } while (0);
+
+/* #define DEBUG_IRQ*/
+
+/*
+ * pointer to the mask representing the additionnal irq vectors
+ * that must be disabled when a particular entry is activated.
+ * They will be dynamically computed from the table given
+ * in BSP_rtems_irq_mngt_set();
+ * CAUTION : this table is accessed directly by interrupt routine
+ * 	     prologue.
+ */
+static unsigned int BSP_irq_prio_mask_tbl[3][BSP_PIC_IRQ_NUMBER];
+
+/*
+ * default handler connected on each irq after bsp initialization
+ */
+static rtems_irq_connect_data	default_rtems_entry;
+
+/*
+ * location used to store initial tables used for interrupt
+ * management.BSP copy of the configuration 
+ */
+static rtems_irq_global_settings	BSP_config;
+
+static volatile unsigned  *BSP_irqMask_reg[3];
+static volatile unsigned  *BSP_irqCause_reg[3];
+static volatile unsigned  BSP_irqMask_cache[3]={0,0,0}; 
+static unsigned int BSP_GPP_mask[4]= { 1<<24, 1<<25, 1<<26, 1<<27};
+
+static int picPrioTblPtr=0;
+static unsigned int GPPIrqInTbl=0;
+static unsigned long long MainIrqInTbl=0;
+
+/* 
+ * The software developers are forbidden to setup picPrioTable[],
+ * as it is a powerful engine for the BSP to find the pending
+ * highest priority IRQ at run time.  It ensures the fastest/faster
+ * interrupt service to the highest/higher priority IRQ, if pendig.
+ *
+ * The picPrioTable[96] is updated dynamically at run time
+ * based on the priority levels set at BSPirqPrioTable[96],
+ * while the BSP_enable_irq_at_pic(), and BSP_disable_irq_at_pic()
+ * commands are invoked.
+ *
+ * The picPrioTable[96] lists the enabled CPU main and GPP external interrupt 
+ * numbers [0 (lowest)- 95 (highest)] starting from the highest priority
+ * one to the lowest priority one. The highest priority interrupt is
+ * located at picPrioTable[0], and the lowest priority interrupt is located
+ * at picPrioTable[picPrioTblPtr-1].
+ *
+ *
+ */
+#define DynamicIsrTable
+#ifdef DynamicIsrTable
+/* BitNums for Main Interrupt Lo/High Cause, -1 means invalid bit */ 
+static unsigned int picPrioTable[BSP_PIC_IRQ_NUMBER]={ 
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1 };
+#else
+static unsigned int picPrioTable[BSP_PIC_IRQ_NUMBER]={ 
+     80, 84, 76, 77, 32, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+     -1, -1, -1, -1, -1, -1 };
+#endif
+
+/*
+ * Check if IRQ is a MAIN CPU internal IRQ or GPP external IRQ
+ */
+static inline int is_pic_irq(const rtems_irq_number irqLine)
+{
+  return (((int) irqLine <= BSP_GPP_IRQ_MAX_OFFSET) &
+	  ((int) irqLine >= BSP_MICL_IRQ_LOWEST_OFFSET)
+	 );
+}
+
+/*
+ * Check if IRQ is a Porcessor IRQ
+ */
+static inline int is_processor_irq(const rtems_irq_number irqLine)
+{
+  return (((int) irqLine <= BSP_PROCESSOR_IRQ_MAX_OFFSET) &
+	  ((int) irqLine >= BSP_PROCESSOR_IRQ_LOWEST_OFFSET)
+	 );
+}
+
+/*
+ * ------------------------ RTEMS Irq helper functions ----------------
+ */
+ 
+/*
+ * Caution : this function assumes the variable "BSP_config"
+ * is already set and that the tables it contains are still valid
+ * and accessible.
+ */
+static void compute_pic_masks_from_prio()
+{
+  int i,j, k, isGppMain;
+  unsigned long long irq_prio_mask=0;
+
+  /*
+   * Always mask at least current interrupt to prevent re-entrance
+   */
+  for (i=0; i <BSP_PIC_IRQ_NUMBER; i++) {
+    switch(i) {
+      case BSP_MAIN_GPP7_0_IRQ:
+      case BSP_MAIN_GPP15_8_IRQ:
+      case BSP_MAIN_GPP23_16_IRQ:
+      case BSP_MAIN_GPP31_24_IRQ:
+	for (k=0; k< 3; k++)
+	    BSP_irq_prio_mask_tbl[k][i]=0;
+
+        irq_prio_mask =0;
+        isGppMain =1;
+        break;
+      default : 
+        isGppMain =0;
+        irq_prio_mask = (unsigned long long) (1LLU << i);
+	break;
+    }
+    if ( isGppMain) continue; 
+    for (j = 0; j <BSP_MAIN_IRQ_NUMBER; j++) {
+        /*
+         * Mask interrupts at PIC level that have a lower priority
+         * or <Till Straumann> a equal priority. 
+         */
+        if (BSP_config.irqPrioTbl [i] >= BSP_config.irqPrioTbl [j])
+	   irq_prio_mask |= (unsigned long long)(1LLU << j);
+    }
+    
+
+    BSP_irq_prio_mask_tbl[0][i] = irq_prio_mask & 0xffffffff;
+    BSP_irq_prio_mask_tbl[1][i] = (irq_prio_mask>>32) & 0xffffffff;
+#if 0
+    printk("irq_mask_prio_tbl[%d]:0x%8x%8x\n",i,BSP_irq_prio_mask_tbl[1][i],
+	   BSP_irq_prio_mask_tbl[0][i]);
+#endif 
+
+    BSP_irq_prio_mask_tbl[2][i] = 1<<i;
+    /* Compute for the GPP priority interrupt mask */
+    for (j=BSP_GPP_IRQ_LOWEST_OFFSET; j <BSP_PROCESSOR_IRQ_LOWEST_OFFSET; j++) {      
+      if (BSP_config.irqPrioTbl [i] >= BSP_config.irqPrioTbl [j])
+	   BSP_irq_prio_mask_tbl[2][i] |= 1 << (j-BSP_GPP_IRQ_LOWEST_OFFSET); 
+    }
+#if 0
+    printk("GPPirq_mask_prio_tbl[%d]:0x%8x\n",i,BSP_irq_prio_mask_tbl[2][i]);
+#endif 
+  }
+}
+
+static void UpdateMainIrqTbl(int irqNum)
+{
+  int i=0, j, k, shifted=0;
+
+  switch (irqNum) {
+    case BSP_MAIN_GPP7_0_IRQ:
+    case BSP_MAIN_GPP15_8_IRQ:
+    case BSP_MAIN_GPP23_16_IRQ:
+    case BSP_MAIN_GPP31_24_IRQ:  
+      return;  /* Do nothing, let GPP take care of it */
+      break;
+  }
+#ifdef SHOW_MORE_INIT_SETTINGS
+  unsigned long val2, val1;
+#endif
+
+  /* If entry not in table*/
+  if ( ((irqNum<BSP_GPP_IRQ_LOWEST_OFFSET) && 
+        (!((unsigned long long)(1LLU << irqNum) & MainIrqInTbl))) ||
+       ((irqNum>BSP_MICH_IRQ_MAX_OFFSET) && 
+        (!(( 1 << (irqNum-BSP_GPP_IRQ_LOWEST_OFFSET)) & GPPIrqInTbl))))
+  { 
+      while ( picPrioTable[i]!=-1) {
+        if (BSP_config.irqPrioTbl[irqNum]>BSP_config.irqPrioTbl[picPrioTable[i]]) {
+          /* all other lower priority entries shifted right */
+          for (j=picPrioTblPtr;j>i; j--) {
+              picPrioTable[j]=picPrioTable[j-1];
+          }
+          picPrioTable[i]=irqNum;
+          shifted=1;
+          break;
+       }
+       i++;
+     }
+     if (!shifted) picPrioTable[picPrioTblPtr] =irqNum;
+
+     if (irqNum >BSP_MICH_IRQ_MAX_OFFSET)
+        GPPIrqInTbl |= (1<< (irqNum-BSP_GPP_IRQ_LOWEST_OFFSET)); 
+     else      
+        MainIrqInTbl |= (unsigned long long)(1LLU << irqNum);
+     picPrioTblPtr++;
+  }
+#ifdef SHOW_MORE_INIT_SETTINGS
+  val2 = (MainIrqInTbl>>32) & 0xffffffff;
+  val1 = MainIrqInTbl&0xffffffff;
+  printk("irqNum %d, MainIrqInTbl 0x%x%x\n", irqNum, val2, val1); 
+  BSP_printPicIsrTbl();
+#endif
+
+}
+
+
+static void CleanMainIrqTbl(int irqNum)
+{
+  int i, j, k;
+
+  switch (irqNum) {
+    case BSP_MAIN_GPP7_0_IRQ:
+    case BSP_MAIN_GPP15_8_IRQ:
+    case BSP_MAIN_GPP23_16_IRQ:
+    case BSP_MAIN_GPP31_24_IRQ: 
+      return;  /* Do nothing, let GPP take care of it */
+      break;  
+  }
+  if ( ((irqNum<BSP_GPP_IRQ_LOWEST_OFFSET) && 
+        ((unsigned long long)(1LLU << irqNum) & MainIrqInTbl)) ||
+       ((irqNum>BSP_MICH_IRQ_MAX_OFFSET) && 
+        (( 1 << (irqNum-BSP_GPP_IRQ_LOWEST_OFFSET)) & GPPIrqInTbl)))
+  { /* If entry in table*/
+     for (i=0; i<64; i++) {
+       if (picPrioTable[i]==irqNum) {/*remove it from the entry */
+          /* all other lower priority entries shifted left */
+	  for (j=i;j<picPrioTblPtr; j++) {
+              picPrioTable[j]=picPrioTable[j+1];
+          }
+          if (irqNum >BSP_MICH_IRQ_MAX_OFFSET)
+            GPPIrqInTbl &= ~(1<< (irqNum-BSP_GPP_IRQ_LOWEST_OFFSET)); 
+          else      
+            MainIrqInTbl &= ~(1LLU << irqNum);
+          picPrioTblPtr--;
+          break;
+       }
+     }
+  }
+}
+
+void BSP_enable_irq_at_pic(const rtems_irq_number irqNum)
+{
+  unsigned bitNum, regNum;
+  unsigned int level;
+
+  bitNum = (((unsigned int)irqNum) - BSP_MICL_IRQ_LOWEST_OFFSET)%32;
+  regNum = (((unsigned int)irqNum) - BSP_MICL_IRQ_LOWEST_OFFSET)>>5;
+
+  rtems_interrupt_disable(level); 
+
+#ifdef DynamicIsrTable
+  UpdateMainIrqTbl((int) irqNum);
+#endif
+  BSP_irqMask_cache[regNum] |= (1 << bitNum);
+
+  out_le32(BSP_irqMask_reg[regNum], BSP_irqMask_cache[regNum]);
+  while (in_le32(BSP_irqMask_reg[regNum]) != BSP_irqMask_cache[regNum]);
+
+  memBar();
+  rtems_interrupt_enable(level);
+}
+
+void BSP_disable_irq_at_pic(const rtems_irq_number irqNum)
+{
+  unsigned bitNum, regNum;
+  unsigned int level;
+
+  bitNum = (((unsigned int)irqNum) - BSP_MICL_IRQ_LOWEST_OFFSET)%32;
+  regNum = (((unsigned int)irqNum) - BSP_MICL_IRQ_LOWEST_OFFSET)>>5;
+
+  rtems_interrupt_disable(level); 
+
+#ifdef DynamicIsrTable
+  CleanMainIrqTbl((int) irqNum);
+#endif
+  BSP_irqMask_cache[regNum] &=  ~(1 << bitNum);
+
+  out_le32(BSP_irqMask_reg[regNum], BSP_irqMask_cache[regNum]);
+  while (in_le32(BSP_irqMask_reg[regNum]) != BSP_irqMask_cache[regNum]);
+  memBar();
+  rtems_interrupt_enable(level);
+}
+
+/* Use shared/irq : 2008 */
+int BSP_setup_the_pic(rtems_irq_global_settings* config)  
+{
+    int i;
+
+    BSP_config = *config;
+
+    switch(BSP_getDiscoveryChipVersion()) {
+    case GT64260B:
+    case GT64260A:
+      /* Get ready for discovery BSP */
+      BSP_irqMask_reg[0]= (volatile unsigned int *) (GT64x60_REG_BASE + GT64260_CPU_INT_MASK_LO);
+      BSP_irqMask_reg[1]= (volatile unsigned int *) (GT64x60_REG_BASE + GT64260_CPU_INT_MASK_HI);
+      BSP_irqCause_reg[0]= (volatile unsigned int *) (GT64x60_REG_BASE + GT64260_MAIN_INT_CAUSE_LO);
+      BSP_irqCause_reg[1]= (volatile unsigned int *) (GT64x60_REG_BASE + GT64260_MAIN_INT_CAUSE_HI);
+      break;
+    default:
+      printk("Not supported by this BSP yet\n");
+      return(0);
+      break;
+    }
+
+    BSP_irqMask_reg[2]= (volatile unsigned int *) (GT64x60_REG_BASE + GT_GPP_Interrupt_Mask);
+    BSP_irqCause_reg[2]= (volatile unsigned int *) (GT64x60_REG_BASE + GT_GPP_Value);
+
+    /* Page 401, Table 598:
+     * Comm Unit Arbiter Control register :
+     * bit 10:GPP interrupts as level sensitive(1) or edge sensitive(0).
+     * MOTload default is set as level sensitive(1). Set it agin to make sure.
+     */
+    outl((inl(GT_CommUnitArb_Ctrl)| (1<<10)), GT_CommUnitArb_Ctrl);
+
+#if 0
+    printk("BSP_irqMask_reg[0] = 0x%x, BSP_irqCause_reg[0] 0x%x\n", 
+	   in_le32(BSP_irqMask_reg[0]),
+	   in_le32(BSP_irqCause_reg[0]));
+    printk("BSP_irqMask_reg[1] = 0x%x, BSP_irqCause_reg[1] 0x%x\n", 
+	   in_le32(BSP_irqMask_reg[1]),
+	   in_le32(BSP_irqCause_reg[1]));
+    printk("BSP_irqMask_reg[2] = 0x%x, BSP_irqCause_reg[2] 0x%x\n", 
+	   in_le32(BSP_irqMask_reg[2]),
+	   in_le32(BSP_irqCause_reg[2]));
+#endif
+
+    /* Initialize the interrupt related  registers */
+    for (i=0; i<3; i++) {
+      out_le32(BSP_irqCause_reg[i], 0);
+      out_le32(BSP_irqMask_reg[i], 0);
+    }         
+    in_le32(BSP_irqMask_reg[2]);
+    compute_pic_masks_from_prio();
+
+#if 0
+    printk("BSP_irqMask_reg[0] = 0x%x, BSP_irqCause_reg[0] 0x%x\n", 
+	   in_le32(BSP_irqMask_reg[0]),
+	   in_le32(BSP_irqCause_reg[0]));
+    printk("BSP_irqMask_reg[1] = 0x%x, BSP_irqCause_reg[1] 0x%x\n", 
+	   in_le32(BSP_irqMask_reg[1]),
+	   in_le32(BSP_irqCause_reg[1]));
+    printk("BSP_irqMask_reg[2] = 0x%x, BSP_irqCause_reg[2] 0x%x\n", 
+	   in_le32(BSP_irqMask_reg[2]),
+	   in_le32(BSP_irqCause_reg[2]));
+#endif
+
+    /*
+     * 
+     */
+    for (i=BSP_MICL_IRQ_LOWEST_OFFSET; i < BSP_PROCESSOR_IRQ_LOWEST_OFFSET ; i++) {
+      if ( BSP_config.irqHdlTbl[i].hdl != BSP_config.defaultEntry.hdl) {
+	BSP_enable_irq_at_pic(i);
+	BSP_config.irqHdlTbl[i].on(&BSP_config.irqHdlTbl[i]);
+      }
+      else {
+	BSP_config.irqHdlTbl[i].off(&BSP_config.irqHdlTbl[i]);
+	BSP_disable_irq_at_pic(i);
+      }
+    }
+    for (i= BSP_MAIN_GPP7_0_IRQ; i < BSP_MAIN_GPP31_24_IRQ; i++) 
+      BSP_enable_irq_at_pic(i);
+    
+    return(1);
+}
+
+/*
+ * High level IRQ handler called from shared_raw_irq_code_entry
+ */
+
+void C_dispatch_irq_handler (CPU_Interrupt_frame *frame, unsigned int excNum)
+{
+  register unsigned msr, new_msr;
+  unsigned long irqCause[3]={0, 0,0};
+  unsigned oldMask[3]={0,0,0};
+  int loop=0, wloop=0, i=0, j;
+  register irq=0, group=0;
+
+  if (excNum == ASM_DEC_VECTOR) {
+    _MSR_GET(msr);
+    new_msr = msr | MSR_EE;
+    _MSR_SET(new_msr);
+    
+    BSP_config.irqHdlTbl[BSP_DECREMENTER].hdl(BSP_config.irqHdlTbl[BSP_DECREMENTER].handle);
+    _MSR_SET(msr);
+    return;
+    
+  }
+
+  for (j=0; j<3; j++ ) oldMask[j] = BSP_irqMask_cache[j];
+  for (j=0; j<3; j++) irqCause[j] = in_le32(BSP_irqCause_reg[j]) & in_le32(BSP_irqMask_reg[j]);
+
+  while (((irq = picPrioTable[i++])!=-1)&& (loop++ < MAX_IRQ_LOOP))
+  {    
+    if (irqCause[group= irq/32] & ( 1<<(irq % 32))) {
+      for (j=0; j<3; j++)
+        BSP_irqMask_cache[j] &= (~ BSP_irq_prio_mask_tbl[j][irq]);
+
+      out_le32(BSP_irqMask_reg[0], BSP_irqMask_cache[0]);
+      out_le32(BSP_irqMask_reg[1], BSP_irqMask_cache[1]);
+      out_le32(BSP_irqMask_reg[2], BSP_irqMask_cache[2]);
+      in_le32(BSP_irqMask_reg[2]);
+      
+      _MSR_GET(msr);
+      new_msr = msr | MSR_EE;
+      _MSR_SET(new_msr); 
+      /* handler */
+#ifdef BSP_SHARED_HANDLER_SUPPORT
+      {
+	 rtems_irq_connect_data* vchain;
+	 for( vchain = &BSP_config.irqHdlTbl[irq];
+	    (vchain->hdl != BSP_config.defaultEntry.hdl && ((int)vchain != -1) );
+	    vchain = (rtems_irq_connect_data*)vchain->next_handler )
+	 {
+	    vchain->hdl(vchain->handle);
+	 }
+      }
+#else
+      BSP_config.irqHdlTbl[irq].hdl(BSP_config.irqHdlTbl[irq].handle);
+#endif
+      _MSR_SET(msr);
+
+      for (j=0; j<3; j++ ) BSP_irqMask_cache[j] = oldMask[j];
+ 
+      out_le32(BSP_irqMask_reg[0], oldMask[0]);
+      out_le32(BSP_irqMask_reg[1], oldMask[1]);
+      out_le32(BSP_irqMask_reg[2], oldMask[2]);
+      in_le32(BSP_irqMask_reg[2]);
+    }
+  }
+}
+
+/* Only print part of the entries for now */
+void BSP_printPicIsrTbl()
+{
+  int i;
+
+  printf("picPrioTable[12]={ irq# :");
+  for (i=0; i<12; i++)
+    printf("%d,", picPrioTable[i]);
+  printf("}\n");
+
+  printf("GPPIrqInTbl: 0x%x :\n", GPPIrqInTbl);
+}
Index: c/src/lib/libbsp/powerpc/mvme5500/irq/irq.h
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/irq/irq.h	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/irq/irq.h	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -30,5 +30,6 @@
 #define LIBBSP_POWERPC_MVME5500_IRQ_IRQ_H
 
-/*#define BSP_SHARED_HANDLER_SUPPORT      1*/
+#define BSP_SHARED_HANDLER_SUPPORT      1
+
 #include <rtems/irq.h>
 
@@ -85,9 +86,9 @@
    * Summary
    */
-#define BSP_IRQ_NUMBER			(BSP_MISC_IRQ_MAX_OFFSET + 1)
+#define BSP_IRQ_NUMBER			(BSP_PIC_IRQ_NUMBER + BSP_PROCESSOR_IRQ_NUMBER)
 #define BSP_MAIN_IRQ_NUMBER             (64)
 #define BSP_PIC_IRQ_NUMBER              (96)
-#define BSP_LOWEST_OFFSET		(BSP_MICL_IRQ_LOWEST_OFFSET)
-#define BSP_MAX_OFFSET			(BSP_MISC_IRQ_MAX_OFFSET)
+#define BSP_LOWEST_OFFSET		(0)
+#define BSP_MAX_OFFSET			(BSP_LOWEST_OFFSET + BSP_IRQ_NUMBER - 1)
 
   /* Main CPU interrupt cause (Low) */
Index: c/src/lib/libbsp/powerpc/mvme5500/irq/irq_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/irq/irq_init.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/irq/irq_init.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -42,8 +42,16 @@
 static rtems_irq_connect_data     	rtemsIrq[BSP_IRQ_NUMBER];
 static rtems_irq_global_settings     	initial_config;
+
+#ifdef BSP_SHARED_HANDLER_SUPPORT
+static rtems_irq_connect_data     	defaultIrq = {
+  /* vectorIdex,  hdl	    ,handle  , on	, off	   , isOn      ,next_handler, */
+  0, 		  nop_func  , NULL   , nop_func	, nop_func , not_connected, 0
+};
+#else
 static rtems_irq_connect_data     	defaultIrq = {
   /* vectorIdex,	 hdl	  , handle	, on		, off		, isOn */
   0, 			 nop_func  , NULL	, nop_func	, nop_func	, not_connected
 };
+#endif
 
 rtems_irq_prio BSPirqPrioTable[BSP_PIC_IRQ_NUMBER]={
@@ -141,25 +149,4 @@
 #endif      
 
-  /*
-   * We must connect the raw irq handler for the two
-   * expected interrupt sources : decrementer and external interrupts.
-   */
-  vectorDesc.exceptIndex 	= ASM_DEC_VECTOR;
-  vectorDesc.hdl.vector	= ASM_DEC_VECTOR;
-  vectorDesc.hdl.raw_hdl	= decrementer_exception_vector_prolog_code;
-  vectorDesc.hdl.raw_hdl_size	= (unsigned) decrementer_exception_vector_prolog_code_size;
-  vectorDesc.on		= nop_func;
-  vectorDesc.off		= nop_func;
-  vectorDesc.isOn		= connected;
-  if (!ppc_set_exception (&vectorDesc)) {
-      BSP_panic("Unable to initialize RTEMS decrementer raw exception\n");
-  }
-  vectorDesc.exceptIndex	= ASM_EXT_VECTOR;
-  vectorDesc.hdl.vector	= ASM_EXT_VECTOR;
-  vectorDesc.hdl.raw_hdl	= external_exception_vector_prolog_code;
-  vectorDesc.hdl.raw_hdl_size	= (unsigned) external_exception_vector_prolog_code_size;
-  if (!ppc_set_exception (&vectorDesc)) {
-      BSP_panic("Unable to initialize RTEMS external raw exception\n");
-    }
 #ifdef TRACE_IRQ_INIT  
   printk("RTEMS IRQ management is now operationnal\n");
Index: c/src/lib/libbsp/powerpc/mvme5500/network/if_100MHz/GT64260eth.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/network/if_100MHz/GT64260eth.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/network/if_100MHz/GT64260eth.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -3,21 +3,14 @@
  * Copyright (c) 2003,2004 Brookhaven National  Laboratory
  *               S. Kate Feng <feng1@bnl.gov>
- * All rights reserved 
+ *               All rights reserved 
  *
  * Acknowledgements:
  * netBSD : Copyright (c) 2002 Allegro Networks, Inc., Wasabi Systems, Inc. 
  * Marvell : NDA document for the discovery system controller
- * The author referenced two RTEMS network drivers of other NICs.
- * rtems : 1) dec21140.c, a network driver for for TULIP based Ethernet Controller
- *            (C) 1999 Emmanuel Raguet. raguet@crf.canon.fr
- *
- *         2) yellowfin.c, a network driver for the SVGM5 BSP.
- *           Stanford Linear Accelerator Center, Till Straumann 
  *
  * Some notes from the author, S. Kate Feng :
  *
  * 1) Mvme5500 uses Eth0 (controller 0) of the GT64260 to implement
- *    the 10/100 BaseT Ethernet with PCI Master Data Byte Swap\
- *    control.
+ *    the 10/100 BaseT Ethernet with PCI Master Data Byte Swap control.
  * 2) Implemented hardware snoop instead of software snoop
  *    to ensure SDRAM cache coherency. (Copyright : NDA item)
@@ -56,4 +49,5 @@
 #include <net/if.h>
 #include <net/if_dl.h>
+#include <net/ethernet.h>
 #include <netinet/in.h>
 #include <netinet/if_ether.h>
@@ -111,5 +105,5 @@
 #define	ET_MINLEN 64		/* minimum message length */
 
-static int GTeth_ifioctl(struct ifnet *ifp, u_long cmd, caddr_t data);
+static int GTeth_ifioctl(struct ifnet *ifp, ioctl_command_t cmd, caddr_t data);
 static void GTeth_ifstart (struct ifnet *);
 static void GTeth_ifchange(struct GTeth_softc *sc);
@@ -170,6 +164,6 @@
 
   if ( (!cause) || (cause & 0x803d00)) {
-       sc->intr_errsts[sc->intr_err_ptr2++]=cause;
-       sc->intr_err_ptr2 %=INTR_ERR_SIZE;   /* Till Straumann */
+       sc->if_errsts[sc->if_err_ptr2]=cause;
+       if ( (++sc->if_err_ptr2) == IF_ERR_BUFSZE) sc->if_err_ptr2=0; /* Till Straumann */
        events |= ERR_EVENT;
   }  
@@ -202,5 +196,5 @@
 	BSP_MAIN_ETH0_IRQ,
 	(rtems_irq_hdl) GT64260eth_isr,
-        NULL,
+        (rtems_irq_hdl_param) NULL,
 	(rtems_irq_enable) GT64260eth_irq_on,
 	(rtems_irq_disable) GT64260eth_irq_off,
@@ -331,7 +325,7 @@
 #endif
 
-  sc->intr_err_ptr1=0;
-  sc->intr_err_ptr2=0;
-  for (i=0; i< INTR_ERR_SIZE; i++) sc->intr_errsts[i]=0;
+  sc->if_err_ptr1=0;
+  sc->if_err_ptr2=0;
+  for (i=0; i< IF_ERR_BUFSZE; i++) sc->if_errsts[i]=0;
 
   /* initialize the hardware (we are holding the network semaphore at this point) */
@@ -339,10 +333,5 @@
 
   /* launch network daemon */
-
-  /* NOTE:
-   * in ss-20011025 (and later) any task created by 'bsdnet_newproc' is
-   * wrapped by code which acquires the network semaphore...
-   */
-   sc->daemonTid = rtems_bsdnet_newproc(GT_ETH_TASK_NAME,4096,GT64260eth_daemon,arg);
+  sc->daemonTid = rtems_bsdnet_newproc(GT_ETH_TASK_NAME,4096,GT64260eth_daemon,arg);
 
   /* Tell the world that we're running */
@@ -365,7 +354,9 @@
   unit = rtems_bsdnet_parse_driver_name(config, &name);
   if (unit < 0) return 0;
- 
-  printk("\nEthernet driver name %s unit %d \n",name, unit);
-  printk("(c) 2004, Brookhaven National Lab. <feng1@bnl.gov> (RTEMS/mvme5500 port)\n");
+  if ( !strncmp((const char *)name,"autoz",5))
+     memcpy(name,"gtMHz",5);
+           
+  printk("\nAttaching GT64260 built-in 10/100 MHz NIC%d\n", unit); 
+  printk("RTEMS-mvme5500 BSP Copyright (c) 2004, Brookhaven National Lab., Shuchen Kate Feng\n");
 
   /* Make certain elements e.g. descriptor lists are aligned. */
@@ -389,19 +380,14 @@
    * by config
    */
-  if (config->hardware_address) {
-     memcpy(hwaddr, config->hardware_address, ETHER_ADDR_LEN);
-  } else {
-    printk("Read EEPROM ");
-     for (i = 0; i < 6; i++)
-       hwaddr[i] = ConfVPD_buff[VPD_ENET0_OFFSET+i];
-  }
+  if (config->hardware_address)
+     memcpy((void *)sc->arpcom.ac_enaddr,(const void *) config->hardware_address, ETHER_ADDR_LEN);
+  else
+    memcpy((void *)sc->arpcom.ac_enaddr, (const void *) &ConfVPD_buff[VPD_ENET0_OFFSET], ETHER_ADDR_LEN);
 
 #ifdef GT_DEBUG
   printk("using MAC addr from device:");
-  for (i = 0; i < ETHER_ADDR_LEN; i++) printk("%x:", hwaddr[i]);
+  for (i = 0; i < ETHER_ADDR_LEN; i++) printk("%x:", sc->arpcom.ac_enaddr[i]);
   printk("\n");
 #endif
-
-  memcpy(sc->arpcom.ac_enaddr, hwaddr, ETHER_ADDR_LEN);
 
   ifp = &sc->arpcom.ac_if;
@@ -411,7 +397,6 @@
   sc->sc_intrmask = inl(ETH0_EIMR) | ETH_IR_MIIPhySTC;
 
+#ifdef GT_DEBUG
   printk("address %s\n", ether_sprintf(hwaddr));
-
-#ifdef GT_DEBUG
   printk(", pcr %x, pcxr %x ", sc->sc_pcr, sc->sc_pcxr);
 #endif
@@ -512,5 +497,4 @@
   struct ifnet *ifp = &sc->arpcom.ac_if;
 
-#if 0
   printf("       Rx Interrupts:%-8lu\n", sc->stats.rxInterrupts);
   printf("     Receive Packets:%-8lu\n", ifp->if_ipackets);
@@ -521,16 +505,8 @@
   printf("         Active Rxqs:%-8u\n",  sc->rxq_active); 
   printf("       Tx Interrupts:%-8lu\n", sc->stats.txInterrupts);
-#endif
-  printf("Multi-BuffTx Packets:%-8lu\n", sc->stats.txMultiBuffPacket);
-  printf("Multi-BuffTx max len:%-8lu\n", sc->stats.txMultiMaxLen);
-  printf("SingleBuffTx max len:%-8lu\n", sc->stats.txSinglMaxLen);
-  printf("Multi-BuffTx maxloop:%-8lu\n", sc->stats.txMultiMaxLoop);
-  printf("Tx buffer max len   :%-8lu\n", sc->stats.txBuffMaxLen);
-#if 0
   printf("   Transmitt Packets:%-8lu\n", ifp->if_opackets);
   printf("   Transmitt  errors:%-8lu\n", ifp->if_oerrors);
   printf("    Tx/Rx collisions:%-8lu\n", ifp->if_collisions);
   printf("         Active Txqs:%-8u\n", sc->txq_nactive); 
-#endif
 }
 
@@ -540,5 +516,5 @@
 }
 
-static int GTeth_ifioctl(struct ifnet *ifp, u_long cmd, caddr_t data)
+static int GTeth_ifioctl(struct ifnet *ifp, ioctl_command_t cmd, caddr_t data)
 {
   struct GTeth_softc *sc = ifp->if_softc;
@@ -586,5 +562,5 @@
 	   if (ifp->if_flags & IFF_RUNNING)
 	      GTeth_ifchange(sc);
-	   else
+           else
 	      error = 0;
        }
@@ -863,4 +839,5 @@
 }
 
+#if 0
 static int txq_high_limit(struct GTeth_softc *sc)
 {
@@ -902,4 +879,5 @@
   return 0;
 }
+#endif
 
 static int GT64260eth_sendpacket(struct GTeth_softc *sc,struct mbuf *m)
@@ -917,8 +895,6 @@
   intrmask = sc->sc_intrmask;
 
-  if ( !(m->m_next)) {/* single buffer packet */
+  if ( !(m->m_next)) /* single buffer packet */
     sc->txq_mbuf[index]= m;
-    sc->stats.txSinglMaxLen= MAX(m->m_len, sc->stats.txSinglMaxLen);
-  }
   else /* multiple mbufs in this packet */
   { 
@@ -948,7 +924,5 @@
 #endif
       len += mtp->m_len;
-      sc->stats.txBuffMaxLen=MAX(mtp->m_len,sc->stats.txBuffMaxLen); 
     }
-    sc->stats.txMultiMaxLoop=MAX(loop, sc->stats.txMultiMaxLoop);
 #if 0
     printk("\n");
@@ -958,6 +932,4 @@
     m_freem(m);
     sc->txq_mbuf[index] = m = mdest;
-    sc->stats.txMultiBuffPacket++;
-    sc->stats.txMultiMaxLen= MAX(m->m_len, sc->stats.txMultiMaxLen);
   }
   if (m->m_len < ET_MINLEN) m->m_len = ET_MINLEN;
@@ -1138,10 +1110,8 @@
 }
 
-/* TOCHECK : Should it be about rx or tx ? */
 static void GTeth_ifchange(struct GTeth_softc *sc)
 {
   if (GTeth_debug>0) printk("GTeth_ifchange(");
   if (GTeth_debug>5) printk("(pcr=%#x,imr=%#x)",inl(ETH0_EPCR),inl(ETH0_EIMR));
-  /*  printk("SIOCADDMULTI (SIOCDELMULTI): is it about rx or tx ?\n");*/
   outl(sc->sc_pcr | ETH_EPCR_EN, ETH0_EPCR);
   outl(sc->sc_intrmask, ETH0_EIMR);
@@ -1446,8 +1416,9 @@
 }
 
+#ifdef GT64260eth_DEBUG
 static void GT64260eth_error(struct GTeth_softc *sc)
 {
   struct ifnet	        *ifp = &sc->arpcom.ac_if;
-  unsigned int		intr_status= sc->intr_errsts[sc->intr_err_ptr1];
+  unsigned int		intr_status= sc->if_errsts[sc->if_err_ptr1];
 
   /* read and reset the status; because this is written
@@ -1472,8 +1443,8 @@
     printk("%s%d: Ghost interrupt ?\n",ifp->if_name,
 	   ifp->if_unit);
-  sc->intr_errsts[sc->intr_err_ptr1++]=0;  
-  sc->intr_err_ptr1 %= INTR_ERR_SIZE;   /* Till Straumann */
-}
-
+  sc->if_errsts[sc->if_err_ptr1]=0;  
+  if ( (++sc->if_err_ptr1) == IF_ERR_BUFSZE) sc->if_err_ptr1=0; /* Till Straumann */
+}
+#endif
 
 /* The daemon does all of the work; RX, TX and cleaning up buffers/descriptors */
@@ -1484,11 +1455,4 @@
   struct mbuf	*m=0;
   struct ifnet	*ifp=&sc->arpcom.ac_if;
-
-#if 0	
-  /* see comments in GT64260eth_init(); in newer versions of
-   * rtems, we hold the network semaphore at this point
-   */
-  rtems_semaphore_release(sc->daemonSync);
-#endif
 
   /* NOTE: our creator possibly holds the bsdnet_semaphore.
@@ -1549,5 +1513,7 @@
 
        /* Log errors and other uncommon events. */
-       if (events & ERR_EVENT) GT64260eth_error(sc); 
+#ifdef GT64260eth_DEBUG
+	  if (events & ERR_EVENT) GT64260eth_error(sc); 
+#endif
   } /* end for(;;) { rtems_bsdnet_event_receive() .....*/
 
Index: c/src/lib/libbsp/powerpc/mvme5500/network/if_100MHz/GT64260eth.h
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/network/if_100MHz/GT64260eth.h	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/network/if_100MHz/GT64260eth.h	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -5,4 +5,5 @@
  * 
  * RTEMS/Mvme5500 port 2004  by S. Kate Feng, <feng1@bnl.gov>,
+ * under the Deaprtment of Energy contract DE-AC02-98CH10886
  * All rights reserved.
  *
@@ -51,5 +52,5 @@
 #define HASH_TABLE_SIZE 16
 #define HASH_DRAM_SIZE  HASH_TABLE_SIZE*1024  /* size of DRAM for hash table */
-#define INTR_ERR_SIZE   16
+#define IF_ERR_BUFSZE   16
 		
 enum GTeth_txprio {
@@ -71,7 +72,7 @@
   struct mbuf* rxq_mbuf[RX_RING_SIZE];	/* receive buffer memory */
   struct GTeth_softc *next_module;
-  volatile unsigned int intr_errsts[INTR_ERR_SIZE]; /* capture the right intr_status */
-  unsigned int intr_err_ptr1;   /* ptr used in GTeth_error() */
-  unsigned int intr_err_ptr2;   /* ptr used in ISR */
+  volatile unsigned int if_errsts[IF_ERR_BUFSZE]; /* capture the right intr_status */
+  unsigned int if_err_ptr1;   /* ptr used in GTeth_error() */
+  unsigned int if_err_ptr2;   /* ptr used in ISR */
   struct ifqueue txq_pendq;	/* these are ready to go to the GT */
   unsigned int txq_pending;
@@ -126,11 +127,5 @@
   struct {
     volatile unsigned long       rxInterrupts;
-
     volatile unsigned long       txInterrupts;
-    unsigned long	txMultiBuffPacket;
-    unsigned long       txMultiMaxLen;
-    unsigned long       txSinglMaxLen;
-    unsigned long       txMultiMaxLoop;
-    unsigned long       txBuffMaxLen;
     unsigned long 	length_errors;
     unsigned long	frame_errors;
